Purchase Slip

This sample demonstrates a Purchase Slip view created with the MultiRow control.

Learn about MultiRow | MultiRow API Reference

import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import * as wjCore from '@mescius/wijmo'; import * as wjPdf from '@mescius/wijmo.pdf'; import * as wjGrid from '@mescius/wijmo.grid'; import * as wjMultiRow from '@mescius/wijmo.grid.multirow'; import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx'; import * as wjGridPdf from '@mescius/wijmo.grid.pdf'; import { getPurchaseSlip } from './data'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { let data = getPurchaseSlip(); let purchaseSlip = new wjMultiRow.MultiRow('#purchaseSlip', { itemsSource: data, layoutDefinition: generateLayoutDef() }); purchaseSlip.columnFooters.rows.push(new wjGrid.Row()); purchaseSlip.columnFooters.setCellData(0, 3, 'Summary'); purchaseSlip.columnFooters.setCellData(0, 6, 'Amount Summary'); let cv = purchaseSlip.collectionView; updateSummary(cv); cv.collectionChanged.addHandler((sender, e) => { let quantity, unitCost; if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) { quantity = +e.item.quantity; unitCost = +e.item.unitCost; if (!isNaN(quantity) && !isNaN(unitCost)) { e.item.cost = quantity * unitCost; e.item.price = e.item.cost * 1.35; updateSummary(cv); } } }); // Generate the layout definition for the MultiRow control. function generateLayoutDef() { let caseDataMap = buildDataMap('small,medium,large'.split(',')); return [ { cells: [ { binding: 'productName', header: 'Product Name', align: 'center', width: 200 } ] }, { cells: [ { binding: 'productId', header: 'Product ID', width: 90 } ] }, { cells: [ { binding: 'color', header: 'Color', align: 'center' }, { binding: 'packageUnit', header: 'Package Unit', align: 'center' } ] }, { cells: [ { binding: 'size', header: 'Size', width: 80 }, { binding: 'case', header: 'Case', dataMap: caseDataMap, width: 80 } ] }, { cells: [ { binding: 'quantity', header: 'Quantity', width: 65 } ] }, { cells: [ { binding: 'deal', header: 'Deal', width: 60 }, { binding: 'id', header: 'ID', width: 60 } ] }, { cells: [ { binding: 'unitCost', header: 'Unit Cost', width: 130, format: 'c2' } ] }, { cells: [ { binding: 'cost', header: 'Cost', width: 90, format: 'c2', isReadOnly: true } ] }, { cells: [ { binding: 'price', header: 'Price', width: 90, format: 'c2', isReadOnly: true } ] }, { cells: [ { binding: 'remarks', header: 'Remarks', align: 'center' } ] } ]; } ; // Update the summary info for the MultiRow control. function updateSummary(cv) { let qtySum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'quantity'), costSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'cost'), priceSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'price'); purchaseSlip.columnFooters.setCellData(0, 4, qtySum); purchaseSlip.columnFooters.setCellData(0, 7, wjCore.Globalize.format(costSum, 'c2')); purchaseSlip.columnFooters.setCellData(0, 8, wjCore.Globalize.format(priceSum, 'c2')); } function buildDataMap(items) { let map = []; for (let i = 0; i < items.length; i++) { map.push({ key: i, value: items[i] }); } return new wjGrid.DataMap(map, 'key', 'value'); } document.querySelector('#exportXlsx').addEventListener('click', () => { wjGridXlsx.FlexGridXlsxConverter.saveAsync(purchaseSlip, null, 'PurchaseSlip.xlsx'); }); document.querySelector('#exportPdf').addEventListener('click', () => { let doc = new wjPdf.PdfDocument({ header: { declarative: { text: '\t&[Page]\\&[Pages]' } }, footer: { declarative: { text: '\t&[Page]\\&[Pages]' } }, ended: function (sender, args) { wjPdf.saveBlob(args.blob, 'PurchaseSlip.pdf'); } }), settings = { styles: { cellStyle: { backgroundColor: '#ffffff', borderColor: '#c6c6c6' }, altCellStyle: { backgroundColor: '#f9f9f9' }, headerCellStyle: { backgroundColor: '#eaeaea' } } }; wjGridPdf.FlexGridPdfConverter.draw(purchaseSlip, doc, null, null, settings); doc.end(); }); }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>MESCIUS Wijmo MultiRow Purchase Slip</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div class="container-fluid"> <div id="purchaseSlip"></div> <div class="btn-group"> <button class="btn btn-default" id="exportXlsx"> Export to Excel </button> <button class="btn btn-default" id="exportPdf"> Export to PDF </button> </div> </div> </body> </html>
export function getPurchaseSlip() { return [ { productId: 'DC0001', productName: 'Chai', color: 'Red', packageUnit: 12, size: '40*30*20', case: 1, quantity: 15, deal: '', id: '', unitCost: 200, cost: 15 * 200, price: 15 * 200 * 1.35, remarks: '' }, { productId: 'DC0002', productName: 'Chang', color: 'Blue', packageUnit: 16, size: '25*35*25', case: 0, quantity: 10, deal: '', id: '', unitCost: 180, cost: 10 * 180, price: 10 * 180 * 1.35, remarks: '' }, { productId: 'DC0003', productName: 'Aniseed Syrup', color: 'Green', packageUnit: 10, size: '50*40*40', case: 2, quantity: 12, deal: '', id: '', unitCost: 150, cost: 12 * 150, price: 12 * 150 * 1.35, remarks: '' }, { productId: 'DC0004', productName: 'Chef Anton\'s Gumbo Mix', color: 'Yellow', packageUnit: 24, size: '30*40*40', case: 1, quantity: 8, deal: '', id: '', unitCost: 220, cost: 8 * 220, price: 8 * 220 * 1.35, remarks: '' }, { productId: 'DC0005', productName: 'Ikura', color: 'Black', packageUnit: 15, size: '20*20*30', case: 0, quantity: 5, deal: '', id: '', unitCost: 300, cost: 5 * 300, price: 5 * 300 * 1.35, remarks: '' }, { productId: 'DC0006', productName: 'Mishi Kobe Niku', color: 'White', packageUnit: 18, size: '25*20*30', case: 0, quantity: 6, deal: '', id: '', unitCost: 360, cost: 8 * 360, price: 8 * 360 * 1.35, remarks: '' } ]; }
.wj-multirow { height: 400px; margin: 6px 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, }, meta: { '*.css': { loader: 'css' }, }, paths: { // paths serve as alias 'npm:': 'node_modules/', 'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/', 'pcdn:': 'https://cdn.jsdelivr.net/npm/' }, // map tells the System loader where to look for things map: { '@mescius/wijmo': 'cdn:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js', jszip: 'pcdn:jszip@3.8.0/dist/jszip.js', 'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css', css: 'pcdn:systemjs-plugin-css@0.1.37/css.js', 'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js', }, node_modules: { defaultExtension: 'js', }, }, }); })(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjMultiRow from '@mescius/wijmo.react.grid.multirow';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjCore from '@mescius/wijmo';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import './app.css';
import { data, layoutDefinition } from './data';
function App() {
const [purchaseSlip, setPurchaseSlip] = useState(null);
const initialized = useEvent((purchaseSlip) => {
setPurchaseSlip(purchaseSlip);
const cv = purchaseSlip.collectionView;
purchaseSlip.columnFooters.rows.push(new wjGrid.Row());
purchaseSlip.columnFooters.setCellData(0, 3, 'Summary');
purchaseSlip.columnFooters.setCellData(0, 6, 'Amount Summary');
updateSummary(purchaseSlip.collectionView, purchaseSlip);
cv.collectionChanged.addHandler((sender, e) => {
let quantity, unitCost;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
quantity = +e.item.quantity;
unitCost = +e.item.unitCost;
if (!isNaN(quantity) && !isNaN(unitCost)) {
e.item.cost = quantity * unitCost;
e.item.price = e.item.cost * 1.35;
updateSummary(purchaseSlip.collectionView, purchaseSlip);
}
}
});
});
const onExportXlsxClick = () => {
if (purchaseSlip) {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(purchaseSlip, undefined, 'PurchaseSlip.xlsx');
}
};
const onExportPdfClick = () => {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, 'PurchaseSlip.pdf');
}
}), settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#C0FFC0'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
};
wjGridPdf.FlexGridPdfConverter.draw(purchaseSlip, doc, undefined, undefined, settings);
doc.end();
};
const updateSummary = (cv, purchaseSlip) => {
let qtySum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'quantity'), costSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'cost'), priceSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.items, 'price');
purchaseSlip.columnFooters.setCellData(0, 4, qtySum);
purchaseSlip.columnFooters.setCellData(0, 7, wjCore.Globalize.format(costSum, 'c2'));
purchaseSlip.columnFooters.setCellData(0, 8, wjCore.Globalize.format(priceSum, 'c2'));
};
return (<div className="container-fluid">
<wjMultiRow.MultiRow id="orderDetail" itemsSource={data} layoutDefinition={layoutDefinition} initialized={initialized}/>
<div className="btn-group">
<button className="btn btn-default" onClick={onExportXlsxClick}>
Export to Excel
</button>
<button className="btn btn-default" onClick={onExportPdfClick}>
Export to PDF
</button>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo MultiRow Purchase Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
import * as wjGrid from '@mescius/wijmo.grid';
function getPurchaseSlip() {
return [
{
productId: 'DC0001',
productName: 'Chai',
color: 'Red',
packageUnit: 12,
size: '40*30*20',
case: 1,
quantity: 15,
deal: '',
id: '',
unitCost: 200,
cost: 15 * 200,
price: 15 * 200 * 1.35,
remarks: ''
},
{
productId: 'DC0002',
productName: 'Chang',
color: 'Blue',
packageUnit: 16,
size: '25*35*25',
case: 0,
quantity: 10,
deal: '',
id: '',
unitCost: 180,
cost: 10 * 180,
price: 10 * 180 * 1.35,
remarks: ''
},
{
productId: 'DC0003',
productName: 'Aniseed Syrup',
color: 'Green',
packageUnit: 10,
size: '50*40*40',
case: 2,
quantity: 12,
deal: '',
id: '',
unitCost: 150,
cost: 12 * 150,
price: 12 * 150 * 1.35,
remarks: ''
},
{
productId: 'DC0004',
productName: 'Chef Anton\'s Gumbo Mix',
color: 'Yellow',
packageUnit: 24,
size: '30*40*40',
case: 1,
quantity: 8,
deal: '',
id: '',
unitCost: 220,
cost: 8 * 220,
price: 8 * 220 * 1.35,
remarks: ''
},
{
productId: 'DC0005',
productName: 'Ikura',
color: 'Black',
packageUnit: 15,
size: '20*20*30',
case: 0,
quantity: 5,
deal: '',
id: '',
unitCost: 300,
cost: 5 * 300,
price: 5 * 300 * 1.35,
remarks: ''
},
{
productId: 'DC0006',
productName: 'Mishi Kobe Niku',
color: 'White',
packageUnit: 18,
size: '25*20*30',
case: 0,
quantity: 6,
deal: '',
id: '',
unitCost: 360,
cost: 8 * 360,
price: 8 * 360 * 1.35,
remarks: ''
}
];
}
function generateLayoutDef() {
let caseDataMap = buildDataMap('small,medium,large'.split(','));
return [
{
cells: [
{ binding: 'productName', header: 'Product Name', align: 'center', width: 200 }
]
},
{
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 }
]
},
{
cells: [
{ binding: 'color', header: 'Color', align: 'center' },
{ binding: 'packageUnit', header: 'Package Unit', align: 'center' }
]
},
{
cells: [
{ binding: 'size', header: 'Size', width: 80 },
{ binding: 'case', header: 'Case', dataMap: caseDataMap, width: 80 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 65 }
]
},
{
cells: [
{ binding: 'deal', header: 'Deal', width: 60 },
{ binding: 'id', header: 'ID', width: 60 }
]
},
{
cells: [
{ binding: 'unitCost', header: 'Unit Cost', width: 130, format: 'c2' }
]
},
{
cells: [
{ binding: 'cost', header: 'Cost', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'price', header: 'Price', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', align: 'center' }
]
}
];
}
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
export const data = getPurchaseSlip();
export const layoutDefinition = generateLayoutDef();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<wj-multi-row :initialized="initSlip" :itemsSource="data" :layoutDefinition="layoutDefinition"></wj-multi-row>
<div class="btn-group">
<button class="btn btn-default" @click="onExportXlsxClick">
Export to Excel
</button>
<button class="btn btn-default" @click="onExportPdfClick">
Export to PDF
</button>
</div>
</div>
</template>
<script setup>
import * as wjCore from "@mescius/wijmo";
import * as wjGrid from "@mescius/wijmo.grid";
import * as wjPdf from "@mescius/wijmo.pdf";
import * as wjGridXlsx from "@mescius/wijmo.grid.xlsx";
import * as wjGridPdf from "@mescius/wijmo.grid.pdf";
import { getPurchaseSlip, generateLayoutDef } from "./data";
import { ref, onMounted } from "vue";
const data = ref(getPurchaseSlip());
const layoutDefinition = ref(generateLayoutDef());
const purchaseSlip = ref(null);
const cv = ref(null);
onMounted(function () {
purchaseSlip.value.columnFooters.rows.push(new wjGrid.Row());
purchaseSlip.value.columnFooters.setCellData(0, 3, "Summary");
purchaseSlip.value.columnFooters.setCellData(0, 6, "Amount Summary");
cv.value = purchaseSlip.value.collectionView;
_updateSummary();
cv.value.collectionChanged.addHandler((sender, e) => {
let quantity, unitCost;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
quantity = +e.item.quantity;
unitCost = +e.item.unitCost;
if (!isNaN(quantity) && !isNaN(unitCost)) {
e.item.cost = quantity * unitCost;
e.item.price = e.item.cost * 1.35;
_updateSummary();
}
}
});
});
function initSlip(purchaseSlipref) {
purchaseSlip.value = purchaseSlipref;
}
function onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(purchaseSlip.value, null, "PurchaseSlip.xlsx");
}
function onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
footer: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, "PurchaseSlip.pdf");
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6",
},
altCellStyle: {
backgroundColor: "#C0FFC0",
},
headerCellStyle: {
backgroundColor: "#eaeaea",
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(purchaseSlip.value, doc, null, null, settings);
doc.end();
}
function _updateSummary() {
let qtySum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.value.items, "quantity"),
costSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.value.items, "cost"),
priceSum = wjCore.getAggregate(wjCore.Aggregate.Sum, cv.value.items, "price");
purchaseSlip.value.columnFooters.setCellData(0, 4, qtySum);
purchaseSlip.value.columnFooters.setCellData(0, 7, wjCore.Globalize.format(costSum, "c2"));
purchaseSlip.value.columnFooters.setCellData(0, 8, wjCore.Globalize.format(priceSum, "c2"));
}
</script>
<style>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Purchase Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import * as wjGrid from '@mescius/wijmo.grid';
export function getPurchaseSlip(){
return [
{
productId: 'DC0001',
productName: 'Chai',
color: 'Red',
packageUnit: 12,
size: '40*30*20',
case: 1,
quantity: 15,
deal: '',
id: '',
unitCost: 200,
cost: 15 * 200,
price: 15 * 200 * 1.35,
remarks: ''
},
{
productId: 'DC0002',
productName: 'Chang',
color: 'Blue',
packageUnit: 16,
size: '25*35*25',
case: 0,
quantity: 10,
deal: '',
id: '',
unitCost: 180,
cost: 10 * 180,
price: 10 * 180 * 1.35,
remarks: ''
},
{
productId: 'DC0003',
productName: 'Aniseed Syrup',
color: 'Green',
packageUnit: 10,
size: '50*40*40',
case: 2,
quantity: 12,
deal: '',
id: '',
unitCost: 150,
cost: 12 * 150,
price: 12 * 150 * 1.35,
remarks: ''
},
{
productId: 'DC0004',
productName: 'Chef Anton\'s Gumbo Mix',
color: 'Yellow',
packageUnit: 24,
size: '30*40*40',
case: 1,
quantity: 8,
deal: '',
id: '',
unitCost: 220,
cost: 8 * 220,
price: 8 * 220 * 1.35,
remarks: ''
},
{
productId: 'DC0005',
productName: 'Ikura',
color: 'Black',
packageUnit: 15,
size: '20*20*30',
case: 0,
quantity: 5,
deal: '',
id: '',
unitCost: 300,
cost: 5 * 300,
price: 5 * 300 * 1.35,
remarks: ''
},
{
productId: 'DC0006',
productName: 'Mishi Kobe Niku',
color: 'White',
packageUnit: 18,
size: '25*20*30',
case: 0,
quantity: 6,
deal: '',
id: '',
unitCost: 360,
cost: 8 * 360,
price: 8 * 360 * 1.35,
remarks: ''
}
];
}
export function generateLayoutDef(){
let caseDataMap = buildDataMap('small,medium,large'.split(','));
return [
{
cells: [
{ binding: 'productName', header: 'Product Name', align: 'center', width: 200 }
]
},
{
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 }
]
},
{
cells: [
{ binding: 'color', header: 'Color', align: 'center' },
{ binding: 'packageUnit', header: 'Package Unit', align: 'center' }
]
},
{
cells: [
{ binding: 'size', header: 'Size', width: 80 },
{ binding: 'case', header: 'Case', dataMap: caseDataMap, width: 80 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 65 }
]
},
{
cells: [
{ binding: 'deal', header: 'Deal', width: 60 },
{ binding: 'id', header: 'ID', width: 60 }
]
},
{
cells: [
{ binding: 'unitCost', header: 'Unit Cost', width: 130, format: 'c2' }
]
},
{
cells: [
{ binding: 'cost', header: 'Cost', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'price', header: 'Price', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', align: 'center' }
]
}
];
}
function buildDataMap(items) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjMultirow from '@mescius/wijmo.grid.multirow';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridMultirowModule } from '@mescius/wijmo.angular2.grid.multirow';
import { DataService, PurchaseSlip, Line } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridMultirowModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements AfterViewInit {
@ViewChild('purchaseSlip', { static: true }) purchaseSlip: wjMultirow.MultiRow;
data: PurchaseSlip[];
layoutDefinition: Line[];
cv: wjCore.CollectionView;
// DataSvc will be passed by derived classes
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.getPurchaseSlip();
this.layoutDefinition = dataService.generateLayoutDef();
}
//
ngAfterViewInit() {
this.purchaseSlip.columnFooters.rows.push(new wjGrid.Row());
this.purchaseSlip.columnFooters.setCellData(0, 3, 'Summary');
this.purchaseSlip.columnFooters.setCellData(0, 6, 'Amount Summary');
this.cv = <wjCore.CollectionView>this.purchaseSlip.collectionView;
this._updateSummary();
this.cv.collectionChanged.addHandler((sender: any, e: wjCore.NotifyCollectionChangedEventArgs) => {
let quantity: number, unitCost: number;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
quantity = +e.item.quantity;
unitCost = +e.item.unitCost;
if (!isNaN(quantity) && !isNaN(unitCost)) {
e.item.cost = quantity * unitCost;
e.item.price = e.item.cost * 1.35;
this._updateSummary();
}
}
});
}
//
onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(this.purchaseSlip, null, 'PurchaseSlip.xlsx');
}
//
onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
ended: function (sender: wjPdf.PdfDocument, args: wjPdf.PdfDocumentEndedEventArgs) {
wjPdf.saveBlob(args.blob, 'PurchaseSlip.pdf');
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6',
},
altCellStyle: {
backgroundColor: '#C0FFC0',
},
headerCellStyle: {
backgroundColor: '#eaeaea',
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(this.purchaseSlip, doc, null, null, settings);
doc.end();
}
//
private _updateSummary() {
let qtySum = wjCore.getAggregate(wjCore.Aggregate.Sum, this.cv.items, 'quantity'),
costSum = wjCore.getAggregate(wjCore.Aggregate.Sum, this.cv.items, 'cost'),
priceSum = wjCore.getAggregate(wjCore.Aggregate.Sum, this.cv.items, 'price');
this.purchaseSlip.columnFooters.setCellData(0, 4, qtySum);
this.purchaseSlip.columnFooters.setCellData(0, 7, wjCore.Globalize.format(costSum, 'c2'));
this.purchaseSlip.columnFooters.setCellData(0, 8, wjCore.Globalize.format(priceSum, 'c2'));
}
}
//\\
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Purchase Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<wj-multi-row #purchaseSlip [itemsSource]="data" [layoutDefinition]="layoutDefinition"></wj-multi-row>
<div class="btn-group">
<button class="btn btn-default" (click)="onExportXlsxClick()">
Export to Excel
</button>
<button class="btn btn-default" (click)="onExportPdfClick()">
Export to PDF
</button>
</div>
</div>
import { Injectable } from '@angular/core';
import * as wjGrid from '@mescius/wijmo.grid';
export interface PurchaseSlip {
productId: string;
productName: string;
color: string;
packageUnit: number;
size: string;
case: number;
quantity: number;
deal: string;
id: string;
unitCost: number;
cost: number;
price: number;
remarks: string;
}
export interface Cell {
binding: string;
header: string;
cssClass?: string;
format?: string;
isReadOnly?: boolean;
wordWrap?: boolean;
width?: number;
colspan?: number;
align?: string;
dataMap?: wjGrid.DataMap;
}
export interface Line {
cells: Cell[];
}
@Injectable()
export class DataService {
getPurchaseSlip(): PurchaseSlip[] {
return [
{
productId: 'DC0001',
productName: 'Chai',
color: 'Red',
packageUnit: 12,
size: '40*30*20',
case: 1,
quantity: 15,
deal: '',
id: '',
unitCost: 200,
cost: 15 * 200,
price: 15 * 200 * 1.35,
remarks: ''
},
{
productId: 'DC0002',
productName: 'Chang',
color: 'Blue',
packageUnit: 16,
size: '25*35*25',
case: 0,
quantity: 10,
deal: '',
id: '',
unitCost: 180,
cost: 10 * 180,
price: 10 * 180 * 1.35,
remarks: ''
},
{
productId: 'DC0003',
productName: 'Aniseed Syrup',
color: 'Green',
packageUnit: 10,
size: '50*40*40',
case: 2,
quantity: 12,
deal: '',
id: '',
unitCost: 150,
cost: 12 * 150,
price: 12 * 150 * 1.35,
remarks: ''
},
{
productId: 'DC0004',
productName: 'Chef Anton\'s Gumbo Mix',
color: 'Yellow',
packageUnit: 24,
size: '30*40*40',
case: 1,
quantity: 8,
deal: '',
id: '',
unitCost: 220,
cost: 8 * 220,
price: 8 * 220 * 1.35,
remarks: ''
},
{
productId: 'DC0005',
productName: 'Ikura',
color: 'Black',
packageUnit: 15,
size: '20*20*30',
case: 0,
quantity: 5,
deal: '',
id: '',
unitCost: 300,
cost: 5 * 300,
price: 5 * 300 * 1.35,
remarks: ''
},
{
productId: 'DC0006',
productName: 'Mishi Kobe Niku',
color: 'White',
packageUnit: 18,
size: '25*20*30',
case: 0,
quantity: 6,
deal: '',
id: '',
unitCost: 360,
cost: 8 * 360,
price: 8 * 360 * 1.35,
remarks: ''
}
];
}
generateLayoutDef(): Line[] {
let caseDataMap = buildDataMap('small,medium,large'.split(','));
return [
{
cells: [
{ binding: 'productName', header: 'Product Name', align: 'center', width: 200 }
]
},
{
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 }
]
},
{
cells: [
{ binding: 'color', header: 'Color', align: 'center' },
{ binding: 'packageUnit', header: 'Package Unit', align: 'center' }
]
},
{
cells: [
{ binding: 'size', header: 'Size', width: 80 },
{ binding: 'case', header: 'Case', dataMap: caseDataMap, width: 80 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 65 }
]
},
{
cells: [
{ binding: 'deal', header: 'Deal', width: 60 },
{ binding: 'id', header: 'ID', width: 60 }
]
},
{
cells: [
{ binding: 'unitCost', header: 'Unit Cost', width: 130, format: 'c2' }
]
},
{
cells: [
{ binding: 'cost', header: 'Cost', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'price', header: 'Price', width: 90, format: 'c2', isReadOnly: true }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', align: 'center' }
]
}
];
}
}
function buildDataMap(items: string[]) {
let map = [];
for (let i = 0; i < items.length; i++) {
map.push({ key: i, value: items[i] });
}
return new wjGrid.DataMap(map, 'key', 'value');
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);